{% extends "layout.html" %} {% block title %}Text Classification &
Augmentation{% endblock %} {% set custom_color = "11, 94, 215" %} {% block bg_color %}rgba(0, 115, 255, .2){% endblock %} {%
block content %}

<h1 class="mb-4 w-100 text-center" > 💬 Text Classification </h1>

<div class="row justify-content-center mt-5">
<!-- Text classification Card 1 ... Begins here -->
  <div class="col-md-6 col-lg-6 col-sm-12 mb-5 max-vw-50">
    <div class="card shadow-custom rounded-4">
      <div class="card-header text-center">Text Classification</div>
      <div class="card-body">
        <div class="row justify-content-center">
          <!-- Card 1 -> Col 1 -->
          <div class="col-md-6 col-lg-6">
            <form method="POST">
              <div class="mb-3">
                <label for="inputText" class="form-label"
                  >Enter Text for Classification</label
                >
                <textarea
                  class="form-control"
                  id="inputText"
                  name="input_text"
                  rows="6"
                  placeholder="Type or paste your text here..."
                  required
                >{{ input_text }}</textarea
                >
              </div>
              <div class="mb-3">
                <label for="modelSelect" class="form-label">Select Model</label>
                <select
                  class="form-select"
                  id="modelSelect"
                  name="model_select"
                  required
                >
                  <option value="original_en" {% if model_input=='original_en' %} selected {% endif %}>English + BERT</option>
                  <option value="original_si" {% if model_input=='original_si' %} selected {% endif %}>Sinhala + BERT</option>
                  <option value="original_tm" {% if model_input=='original_tm' %} selected {% endif %}>Tamil + BERT</option>
                  <option value="augmented_en" {% if model_input=='augmented_en' %} selected {% endif %}>English + SSwap + BERT</option>
                  <option value="augmented_si" {% if model_input=='augmented_si' %} selected {% endif %}>Sinhala + SSwap + BERT</option>
                  <option value="augmented_tm" {% if model_input=='augmented_tm' %} selected {% endif %}>Tamil + SSwap + BERT</option>
                </select>
              </div>
              <button type="submit" class="btn btn-primary w-100 mb-3 rounded-5 fw-bold">
                <i class="fa-solid fa-layer-group me-2"></i> Classify
              </button>
            </form>
          </div>

          <!-- Card 1 -> Col 2 -->
          <div class="col-md-6 col-lg-6">
            <div class="confidence-levels mb-3">
                <label for="inputText" class="form-label mb-3"
                  >Classification Results</label>
              {% if predictions %} {% set max_confidence = predictions.values() | max %} {% for label, confidence in predictions.items() %}
              <div class="d-flex justify-content-between mb-1">
                <span>{{ label }}</span>
                <span class="confidence {% if confidence < max_confidence %}disable{% endif %}">{% if confidence == max_confidence %} <i class="fa-solid fa-star"></i> {% endif %}{{ confidence }}%</span>
              </div>
              <div class="progress mb-3">
                <div
                  class="progress-bar {% if confidence < max_confidence %}disable{% endif %}"
                  role="progressbar"
                  style="width: {{ confidence }}%;"
                  aria-valuenow="{{ confidence }}"
                  aria-valuemin="0"
                  aria-valuemax="100"
                ></div>
              </div>
              {% endfor %} {% else %} {% for l in labels %}
              <div class="mb-3">
                <div class="d-flex justify-content-between mb-1">
                  <span>{{ l }}</span>
                  <!-- <span class="confidence">0%</span> -->
                </div>
                <div class="progress">
                  <div
                    class="progress-bar"
                    role="progressbar"
                    style="width: 0%"
                    aria-valuenow="0"
                    aria-valuemin="0"
                    aria-valuemax="100"
                  ></div>
                </div>
              </div>
              {% endfor %} {% endif %}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
<!-- Data Augmentation Card 2 ... Begins here -->
  <div class="col-md-6 col-lg-6 col-sm-12 mb-5 max-vw-50">
    <div class="card shadow-custom rounded-4">
      <div class="card-header card-header-success text-center">
        Data Augmentation
      </div>
      <div class="card-body">
        <div class="row justify-content-center">
        <!-- Card 2 -> Col 1 -->
        <div class="col-md-6 col-lg-6 mb-6">
            <form method="POST">
                <div class="mb-3">
                <label for="sentence1" class="form-label">Sentence 1</label>
                <textarea
                class="form-control"
                id="sentence1"
                name="sentence1"
                rows="2"
                placeholder="Enter the first sentence"
                required
                >{{ sentence1[0] }}</textarea
                >
              </div>
              <div class="mb-3">
                <select
                class="form-select"
                id="sentence2Model"
                name="sentence1_label"
                required
                >
                {% for l in labels %}
                <option value="{{l}}" {% if l == sentence1[1] %} selected {% endif %}>{{l}}</option>
                {% endfor %}
              </select>
            </div>
            <div class="mb-3">
              <label for="sentence2" class="form-label">Sentence 2</label>
              <textarea
              class="form-control"
              id="sentence2"
              name="sentence2"
              rows="2"
              placeholder="Enter the second sentence"
              required
              >{{ sentence2[0] }}</textarea
              >
            </div>
            <div class="mb-3">
              <select
              class="form-select"
                id="sentence2Model"
                name="sentence2_label"
                required
                >
                {% for l in labels %}
                <option value="{{l}}" {% if l == sentence2[1] %} selected {% endif %}>{{l}}</option>
                {% endfor %}
                </select>
              </div>
              <label for="shap_model" class="form-label">Select Model</label>
              <div class="mb-3">
                <select
                class="form-select"
                id="shap_model"
                name="shap_model"
                required
                >
                <option value="en" {% if shap_model=='en' %} selected {% endif %}>English</option>
                <option value="si" {% if shap_model=='si' %} selected {% endif %}>Sinhala</option>
                <option value="tm" {% if shap_model=='tm' %} selected {% endif %}>Tamil</option>
                </select>
            </div>
            
            <div class="mb-3">
              <label for="thresh" class="form-label">Threshold</label>
              <input type="number" class="form-control" id="thresh" name="thresh" value="85">
            </div>

            <button type="submit" class="btn btn-success btn-purple w-100  rounded-5 fw-bold">
                <i class="fa-solid fa-shuffle btn-icon me-2"></i> Augment
            </button>
            </form>
        </div>
        <!-- Card 2 -> Col 2 -->
        <div class="col-md-6 col-lg-6 mb-6">
          
            <label class="form-label">Augmented Sentences</label>
            {% if augmented_sentences %}
            {% set aug_s = augmented_sentences | list %}
            <div class="overflow-auto" style="height:26rem">
                
                {% for s, l in aug_s %}
                {% if l == sentence1[1] %}
                <div class="alert alert-purple">
                    <p class="">{{ s }}</p>
                    <!-- <p class="">{{ l }}</p> -->
                </div>
                {% endif %}
                {% endfor %}
                <!-- NOT desired label -->
                {% for s, l in aug_s %}
                {% if l != sentence1[1] %}
                <div class="alert alert-disable">
                    <p class="">{{ s }}</p>
                    <p class="p-0">{{ l }}</p>
                </div>
                {% endif %}
                {% endfor %}
            </div>
                {% endif %}
        </div>
        </div>

        
      </div>
    </div>
  </div>
</div>



{% endblock %}
